<?xml version='1.0' encoding='utf-8'?>
| <!DOCTYPE rfc SYSTEM "rfc2629-xhtml.ent" [
// external reference to RFCs
<!ENTITY rfc7991 SYSTEM "http://xml.resource.org/public/rfc/bibxml/reference.RFC.7991.xml">
<!ENTITY rfc6949 SYSTEM "http://xml.resource.org/public/rfc/bibxml/reference.RFC.6949.xml">
<!ENTITY rfc2026 SYSTEM "http://xml.resource.org/public/rfc/bibxml/reference.RFC.2026.xml">
<!ENTITY rfc2360 SYSTEM "http://xml.resource.org/public/rfc/bibxml/reference.RFC.2360.xml">
<!ENTITY rfc2119 SYSTEM "http://xml.resource.org/public/rfc/bibxml/reference.RFC.2119.xml">
| ]>

// processing instructions
<?rfc toc="yes"?>
<?rfc symrefs="yes"?>
<?rfc compact="yes"?>
<?rfc subcompact="no"?>
<?rfc strict="no"?>
<?rfc rfcedstyle="yes"?>
<?rfc comments="yes"?>
<?rfc inline="yes"?>

rfc(category='std' number='2417678' consensus='true' ipr='trust200902' docName='en-smm-apc-doc-guidelines-01' submissionType='be-cem-mro' obsoletes='' updates='' xml:lang='en' version='3' xmlns:xi='http://www.w3.org/2001/XInclude')
  front
    title(abbrev='EN-SMM-APC doc & spec guidelines') EN-SMM-APC Documentation &amp; Specification Guidelines
    author(fullname='Sylvain Fargier' initials='S.F.' role='editor' surname='Fargier')
      organization CERN
      address
        postal
          street 1, Esplanade des Particules
          code 1217
          city Meyrin
          country Switzerland
        email sylvain.fargier@cern.ch
    date(year='2019' month='March')
    abstract
      t This document describes EN-SMM-APC team documentation and specification guidelines.
  middle
    section
      name Introduction
      t
        | This document is a reference document for the EN-SMM-APC team,
        | describing the documentation and specification recommendations.

      // This one is a 'must' :)
      section
        name Requirements Notation
        t
          | The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT",
          | "SHOULD", "SHOULD NOT", "RECOMMENDED", "MAY", and "OPTIONAL" in this
          | document are to be interpreted as described in BCP 14,
          | #[xref(target='RFC2119' format='default') RFC2119].

    section
      name Document Streams
      t
        | Documents are organized in streams produced by a given team, group or
        | task force.

      t
        | As an example this document is part of the "en-smm-apc" stream, that is
        | produced by EN-SMM-APC team members.

      t
        | In each document, the stream #[bcp14 MUST] be set in the
        | submissionType attribute of the rfc tag,
        | see #[xref(target="FILE_FORMAT")] for details on file format.

    section
      name Document Categories
      t The EN-SMM-APC team documentation is split in five different categories: STD, EXP, BCP, Info, Historic
      t
        | Those categories can be mapped on regular RFC categories, see
        | #[xref(target='RFC2026') RFC2026 section 4].

      t
        | In each document, the category #[bcp14 MUST] be
        | set using a value amongst: std, exp, bcp, info, historic in the
        | category attribute of the rfc tag,
        | see #[xref(target="FILE_FORMAT")] for details on file format.

      section
        name Standards Track
        t
          | A Standard Track (STD) specification for which significant
          | implementation and successful operational experience has been
          | obtained.

      section
        name Experimental
        t
          | The experimental (EXP) category denotes a specification that is part
          | of some research or development effort. Such a specification is
          | published for examination, experimental implementation and
          | evaluation.

      section
        name Informational
        t
          | The informational (Info) category aggregates informational facts,
          | it #[bcp14 SHOULD NOT] be considered as a
          | specification or recommendation document.

      section
        name Historic
        t
          | The historic (Historic) category denotes a specification that has been
          | superseded by a more recent specification or is for any other
          | reason considered obsolete.

      section
        name Best Current Practice
        t
          | The Best Current Practice (BCP) is a way to standardise practices,
          | recommendations on what is believed to be the best way
          | to perform some operations.

    section
      name Document Status
      t
        | Documents #[bcp14 MUST] first be created as Drafts, before being
        | promoted as one of the categories described above.

      t
        | Drafts #[bcp14 MUST] be reviewed by the stream's management team within
        | a six month period whereupon the draft expires.

      t
        | Once reviewed a draft #[bcp14 MAY] be promoted by registering it in
        | #[xref(target="EDMS") CERN's Engineering Data Management Service].

      t
        | It is #[bcp14 RECOMMENDED] to register a pdf version of the document.

      t
        | In the specification document, the EDMS identifier #[bcp14 MUST] be
        | set in the number attribute of the rfc tag,
        | see #[xref(target="FILE_FORMAT")] for details on file format.

      section
        name Document Version
        t
          | Once the document promoted, its version #[bcp14 MUST] be incremented
          | on every modification, adding an entry in the 'Change Log' section
          | and updating its name.

        t
          | In each document the document version is set as the suffix in the
          | docName attribute of the rfc tag,
          | see #[xref(target="FILE_FORMAT")] for details on file format.

        t
          | The source (pug, xml ...) of documents #[bcp14 SHOULD] be versionned
          | using a SCM (Source Control Management), it is #[bcp14 RECOMMENDED]
          | to use Git to do so.

    section
      name Document Consensus
      t
        | A document that has been reviewed by other teams and that is accepted
        | as a general documentation #[bcp14 SHOULD] be flagged as such, by adding
        | a notice and the list of reviewers in the document.

      t
        | In the specification document, the consensus state #[bcp14 MUST] be
        | added as a boolean value on consensus attribute of the rfc tag,
        | see #[xref(target="FILE_FORMAT")] for details on file format.

    section
      name Document Artwork
      t
        | It is #[bcp14 RECOMMENDED] to use "line art" diagrams and prefer text
        | based representations, see #[xref(target='RFC6949')] for pro/cons.

      t
        | Writers #[bcp14 SHOULD] refer to #[xref(target='RFC2360')] for
        | recommendations on how to draw diagrams, tools such as
        | #[xref(target='ASCIIFLOW')] #[bcp14 MAY] also be used.

      t
        | Writers #[bcp14 MAY] use external references to SVG or images files,
        | but a comprehensive text description or a "line art" version of the
        | document #[bcp14 SHOULD] be available.

      t
        | Those files #[bcp14 MUST] be versionned along with the source document,
        | at the same level and in a directory that #[bcp14 MUST] match the
        | source document basename.

    section(anchor="FILE_FORMAT")
      name File Format and Tools
      t
        | Documentation and specification #[bcp14 MUST] be written in a
        | #[xref(target="WIKIPEDIA_RFC") Request For Comments] documents style.

      t
        | Writers #[bcp14 SHOULD] use the XML format described in
        | #[xref(target="RFC7991")], documents written using this language
        | #[bcp14 MUST] use '.xml' file extension.

      t
        | The #[xref(target="PUG") pug] language is supported and #[bcp14 MAY]
        | be used by document writers, documents written using this language
        | #[bcp14 MUST] use '.pug' file extension.

      section
        name Tools
        t
          | The #[xref(target="CERN_XML2RFC") CERN's xml2rfc] tool #[bcp14 MUST]
          | be used to generate published documentation.

        t
          | It is #[bcp14 RECOMMENDED] to use the docker container as described
          | in #[xref(target="CERN_XML2RFC")] to work on documents.

    section
      name EN-SMM-APC Stream
      t
        | The "en-smm-apc" stream regroups documents written by the EN-SMM-APC
        | section.

      t
        | Documents #[bcp14 MUST] be archived on the associated
        | #[xref(target="APC_DOCS") documentation repository], even ongoing
        | drafts.

      t
        | Documents archived on the #[xref(target="APC_DOCS") documentation repository]
        | will automatically be pre-published on the #[xref(target="APC_DOCS_WEB") documentation website].

  back
    references
      name References
      references
        name Normative References
        | &rfc2026;
        | &rfc2119;
        | &rfc7991;

      references
        name Informative References
        | &rfc6949;
        | &rfc2360;

      references
        name URL References
        reference(anchor="CERN_XML2RFC" target="https://gitlab.cern.ch/apc/common/xml2rfc")
          front
            title CERN's fork of the XML2RFC tool
            author
              organization RFC Editor &amp; CERN

        reference(anchor="APC_DOCS" target="https://gitlab.cern.ch/apc/common/docs")
          front
            title EN-SMM-APC team docs
            author
              organization CERN

        reference(anchor="APC_DOCS_WEB" target="https://www.cern.ch/apc-dev/rfc")
          front
            title EN-SMM-APC pre-publication website
            author
              organization CERN

        reference(anchor="EDMS" target="https://edms.cern.ch")
          front
            title CERN's Engineering Data Management Service
            author
              organization CERN

        reference(anchor='XML2RFC' target='http://xml.resource.org')
          front
            title XML2RFC tools and documentation
            author
              organization RFC Editor
            date(year='2013')

        reference(anchor="WIKIPEDIA_RFC" target="https://en.wikipedia.org/wiki/Request_for_Comments")
          front
            title RFC wikipedia page
            author
              organization Wikipedia

        reference(anchor="PUG" target="https://pugjs.org")
          front
            title Pug template engine
            author
              organization Pugjs.org

        reference(anchor="ASCIIFLOW" target="http://asciiflow.com")
          front
            title AsciiFlow tool
            author(fullname="Lewis Hemens")

    section
      name Example
      t An example #[xref(target="PUG")] document.
      figure
        name An example document
        sourcecode(name="example.pug" type="pug")
          | <![CDATA[
          |  <?xml version='1.0' encoding='utf-8'?>
          |  | &lt;!DOCTYPE rfc SYSTEM "rfc2629-xhtml.ent" [
          |  <!ENTITY rfc7991 SYSTEM "http://xml.resource.org/public/rfc/bibxml/reference.RFC.7991.xml">
          |  <!ENTITY rfc2119 SYSTEM "http://xml.resource.org/public/rfc/bibxml/reference.RFC.2119.xml">
          |  | ]>
          |
          |  // processing instructions
          |  <?rfc toc="yes"?>
          |  <?rfc symrefs="yes"?>
          |  <?rfc compact="yes"?>
          |  <?rfc subcompact="no"?>
          |  <?rfc strict="no"?>
          |  <?rfc rfcedstyle="yes"?>
          |  <?rfc comments="yes"?>
          |  <?rfc inline="yes"?>
          |
          |  rfc(category="std" consensus='true' ipr='trust200902' docName='example-std-01' submissionType='be-cem-mro' obsoletes='' updates='' xml:lang='en' version='3' xmlns:xi='http://www.w3.org/2001/XInclude')
          |    front
          |      title(abbrev='Example Document') Example Document
          |      author(fullname='Sylvain Fargier' initials='S.F.' role='editor' surname='Fargier')
          |        address
          |          email sylvain.fargier@cern.ch
          |      date(year='2019')
          |      abstract
          |        t This is an example document.
          |    middle
          |      section
          |        name Introduction
          |        t
          |          | This is an example document, for templates documents with included
          |          | documentation, please refer to
          |          | #[xref(target="APC_DOCS_WEB") documentation website].
          |
          |        // This one is a 'must' :)
          |        section
          |          name Requirements Notation
          |          t
          |            | The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT",
          |            | "SHOULD", "SHOULD NOT", "RECOMMENDED", "MAY", and "OPTIONAL" in this
          |            | document are to be interpreted as described in BCP 14,
          |            | #[xref(target='RFC2119' format='default') RFC2119].
          |
          |      section
          |        name About
          |        t
          |          | This document is written according to #[xref(target="RFC7991")] using
          |          | the #[xref(target="PUG") pug] language.
          |
          |    back
          |      references
          |        name References
          |        references
          |          name Normative References
          |          | &rfc2119;
          |          | &rfc7991;
          |
          |        references
          |          name URL References
          |          reference(anchor="APC_DOCS_WEB" target="https://www.cern.ch/apc-dev/rfc")
          |            front
          |              title EN-SMM-APC pre-publication website
          |              author
          |                organization CERN
          |          reference(anchor="PUG" target="https://pugjs.org")
          |            front
          |              title Pug template engine
          |              author
          |                organization Pugjs.org
          | ]]>

    section
      name Change Log
      dl
        dt 01
        dd First revision
